﻿namespace SharpObservation.Tests.Dummy
{
    internal class NotifyDummy : ObservableObject
    {
        /// <summary>
        /// Backing Field: The name of the account
        /// </summary>
        private string _name;

        /// <summary>
        /// Declares a prototype for the name property 
        /// </summary>
        public static Property<NotifyDummy, string> NameProperty = 
                  new Property<NotifyDummy, string>(
                      c => c.Name,               // Lambda...  survives property renames
                      c => c._name,              // field getter
                      (c, v) => c._name = v);    // field setter

        /// <summary>
        /// Gets or Sets the Name of the account
        /// </summary>
        public string Name
        {
            get { return _name; }
            set { NameProperty.Set(this, value); }       // Nice, compact property setter
        }
    }
}