﻿using System;
using System.ComponentModel;
using System.Threading;
using SharpObservation.Tests.Dummy;
using SharpObservation.Virtual;

namespace SharpObservation.Tests
{
    public class TestInfo : DisposableObject
    {
        public readonly AutoResetEvent WaitHandle = new AutoResetEvent(false);
        private readonly VirtualCollection<DummyDataItem> _collection;
        private readonly DummyItemsProvider _provider;

        public TestInfo(bool threadsafe = false, int pageSize = 1000)
        {
            _provider = new DummyItemsProvider { Count = 10000, IsThreadSafe = threadsafe };
            _collection = new VirtualCollection<DummyDataItem>(Provider, pageSize);
            _collection.PropertyChanged += PropertyChanged;
        }

        public VirtualCollection<DummyDataItem> Collection
        {
            get { return _collection; }
        }

        public DummyItemsProvider Provider
        {
            get { return _provider; }
        }

        public void PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            WaitHandle.Set();
        }
    }
}