#region

using System.ComponentModel;
using System.Diagnostics;

#endregion

namespace SharpObservation
{
    /// <summary>
    ///   Provides rich information about a property change event
    /// </summary>
    /// <typeparam name = "T">The typeToMatch fo the _property that changed</typeparam>
    public class PropertyChangedEventArgs<T> : PropertyChangedEventArgs
    {
        private readonly T _current;
        private readonly T _previous;

        /// <summary>
        ///   Constructs a new instance of PropertyChangedEventArgs
        /// </summary>
        /// <param name = "propertyName">The name of the changes _property</param>
        /// <param name = "previous">The factory  of the _property</param>
        /// <param name = "current">The factory  of the _property</param>
        public PropertyChangedEventArgs(string propertyName, T previous, T current)
            : base(propertyName)
        {
            Debug.Assert(propertyName != null);
            _previous = previous;
            _current = current;
        }

        /// <summary>
        ///   Gets the factory  of the _property
        /// </summary>
        public T Previous
        {
            get { return _previous; }
        }

        /// <summary>
        ///   Gets the factory  of the _property
        /// </summary>
        public T Current
        {
            get { return _current; }
        }
    }
}