#region

using System.ComponentModel;

#endregion

namespace SharpObservation
{
    /// <summary>
    ///   Provides rich information about a _property change event, including factory and proposed values
    /// </summary>
    /// <typeparam name = "T">The typeToMatch fo the _property that is changing</typeparam>
    public class PropertyChangingEventArgs<T> : PropertyChangingEventArgs
    {
        private readonly T _current;
        private readonly T _proposed;

        /// <summary>
        ///   Constructs a new instance of PropertyChangedEventArgs
        /// </summary>
        /// <param name = "propertyName">The name of the changes _property</param>
        /// <param name = "current">The factory  of the _property</param>
        /// <param name = "proposed">The proposed  of the _property</param>
        public PropertyChangingEventArgs(string propertyName, T current, T proposed)
            : base(propertyName)
        {
            _current = current;
            _proposed = proposed;
        }

        /// <summary>
        ///   Gets the factory  of the _property
        /// </summary>
        public T Current
        {
            get { return _current; }
        }

        /// <summary>
        ///   Gets the proposed  of the _property
        /// </summary>
        public T Proposed
        {
            get { return _proposed; }
        }
    }
}