﻿#region

using System.Collections.Generic;

#endregion

namespace SharpObservation
{
    /// <summary>
    ///   A collection of weak referenced items
    /// </summary>
    /// <typeparam name = "TItem">The type of item in the collection</typeparam>
    public class WeakReferenceCollection<TItem> : ReferenceCollection<TItem, WeakReference<TItem>>
        where TItem : class
    {
        /// <summary>
        ///   Initializes a new instance of the <see cref = "WeakReferenceCollection{TItem}" /> class.
        /// </summary>
        public WeakReferenceCollection() : base(i => new WeakReference<TItem>(i))
        {
        }

        /// <summary>
        ///   Initializes a new instance of the <see cref = "WeakReferenceCollection{TItem}" /> class.
        /// </summary>
        /// <param name = "items">The items.</param>
        public WeakReferenceCollection(IEnumerable<TItem> items)
            : base(i => new WeakReference<TItem>(i), items)
        {
        }
    }
}